/** This gauss programme (written for Gauss6) is to replicate the results reported in:
Holly, S., M.H. Pesaran, T. Yamagata (2011), The spatial and temporal diffusion of house prices in the UK, Journal of Urban Economics 69 2-23. We do not take any responsibility for possible loss which might be caused by using this programme.
**/  

new;output file = Z:\\ty509\\Gauss6.0\\0myproc\\UKHP_for_UK_Results_Gauss6\\HPY_UKHP_out.txt reset;
outwidth 256;
charctrsticvalue=0;/** if 1, reporting eigenvalue of companion form **/
impulseresponse=0;/** if 1, generalised impulse response (GIRF) analysis will be reported in excel file (in SHEAT3), at drctry2 and drctry3 **/

drctry2="Z:\\ty509\\Gauss6.0\\0myproc\\UKHP_for_UK_Results_Gauss6\\girf_aic_restrict.xls";/** directory for level (GIRF) results**/
drctry3="Z:\\ty509\\Gauss6.0\\0myproc\\UKHP_for_UK_Results_Gauss6\\dgirf_aic_restrict.xls";/** directory for difference (GIRF) results**/
drctry4="Z:\\ty509\\Gauss6.0\\0myproc\\UKHP_for_UK_Results_Gauss6\\LRHP_UK_NY_UK(S).xls";/** directory for data file **/

leveldatao=xlsreadm(drctry4,"b2:m140",1,"");/*data=100*data;*/
datanameo=xlsreadm(drctry4,"b1:m1",2,"");
Smat=xlsreadm(drctry4,"b2:m13",2,"");
csnameo=xlsreadm(drctry4,"a15:a26",2,"");
Smat=Smat./sumc(smat');
leveldataso=leveldatao*Smat';
datao=leveldatao-lag(leveldatao);
dataso=leveldataso-lag(leveldataso);
datao=trim(datao,1,0);
dataso=trim(dataso,1,0);
leveldatao=trim(leveldatao,0,1);/* lagged already!!*/
leveldataso=trim(leveldataso,0,1);/* lagged already!!*/

pv={4,4,4};
p0={1,1,0};
aic=2;
do while aic<=2;
hwvmat={};
c_base=0;
do while c_base<=0;
/* REPLACE ABOVE LINE IF YOU WANT TO CHANGE THE BASE REGION BY
do while c_base<=cols(datao)-1;*/


data=rotater(datao,-c_base);
datas=rotater(dataso,-c_base);
leveldata=rotater(leveldatao,-c_base);
leveldatas=rotater(leveldataso,-c_base);
csname=rotater(csnameo',-c_base)';
dataname=rotater(datanameo,-c_base);
/** 0: no selection of lag order, 1: with aic 2: with sbc*/
shocki=1;/* NW*/

n=cols(data);
t=rows(data);

/** for obtaining matrices for GIRF **/
maxp=maxc(pv);
tvec={};
avec=zeros(n,1);
amat_temp=zeros(n,maxp);
gmat_temp=zeros(n,maxp);
cmat_temp=zeros(n,maxp+1);
emat=zeros(t-1,n);


lgv={};
ase={};
acov={};
gcov={};
ccov={};
pvi_aic_v={};
ccov2=100000000;
hwv={};
rsq_bar_v={};
ctratio=zeros(n,1);
ecmcoef1={};
ecmcoef2={};
ecmtratio1={};
ecmtratio2={};
ecmjointf={};
pvaluef={};


/***/

/** firstly only london for hausman-wu test **/
y0=data[.,1];
y0s=datas[.,1];

y0name=dataname[1];
y0sname=y0name $+ "s";
data0=y0~y0s;
/*ecm1_0j=leveldata[.,j]-leveldata[.,1];*/
ecm2_00=leveldata[.,1]-leveldatas[.,1];
if aic==0;pv0_aic=pv[1:2];
else;
combi0=pcombi(pv[1:2],p0[1:2]);
ic0={};
c_p=1;
do while c_p<=rows(combi0);
{zname,ndata}=ardl(y0name~y0sname,data0,combi0[c_p,.]',p0[1:2]);
ndata=trim(ndata,maxc(pv[1:2])-maxc(combi0[c_p,.]'),0);
ndata=ndata/*~ecm1_0j[rows(ecm1_0j)-rows(ndata)+1:rows(ecm1_0j),.]*/
~ecm2_00[rows(ecm2_00)-rows(ndata)+1:rows(ecm2_00),.];
{beta,se,tstat,e0,ic,cov0,rsq_Bar0}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
c_p=c_p+1;
ic0=ic0|ic';
endo;
    if aic==1;
        pv0_aic=combi0[minindc(ic0[.,1]),.]';
        elseif aic==2;pv0_aic=combi0[minindc(ic0[.,2]),.]';
    endif;
endif;
{zname,ndata}=ardl(y0name~y0sname,data0,/*pv[1:2]*/pv0_aic,p0[1:2]);
ndata=ndata/*~ecm1_0j[rows(ecm1_0j)-rows(ndata)+1:rows(ecm1_0j),.]*/
~ecm2_00[rows(ecm2_00)-rows(ndata)+1:rows(ecm2_00),.];
{beta,se,tstat,e0,ic,cov0,rsq_Bar0}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));

/** RESTRICT THE EC TERMS (ONLY SIGNIFICANT TERMS INCLUDED AT 5% |1.96|<|t|)*/
if abs(tstat[rows(beta)-1])>1.96;ndata=ndata[.,1:cols(ndata)-1];
ecmcoef2=ecmcoef2|beta[rows(beta)-1];
ecmtratio2=ecmtratio2|tstat[rows(beta)-1];
ecmjointf=ecmjointf|(abs(tstat[rows(beta)-1])^2);
pvaluef=pvaluef|cdffc(abs(tstat[rows(beta)-1])^2,1,rows(ndata)-rows(beta));
elseif abs(tstat[rows(beta)-1])<=1.96;ndata=ndata[.,1:cols(ndata)-1];
ecmjointf=ecmjointf|(abs(tstat[rows(beta)-1])^2);
pvaluef=pvaluef|cdffc(abs(tstat[rows(beta)-1])^2,1,rows(ndata)-rows(beta));
{beta,se,tstat,e0,ic,cov0,rsq_Bar0}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
ecmcoef2=ecmcoef2|0;
ecmtratio2=ecmtratio2|_dxmiss;
chistat=_dxmiss;
endif;
/*$(zname[2:cols(zname)]~"inpt")'~ftocv(beta~tstat,1,3);*/rsq_bar_v=rsq_bar_v|rsq_Bar0;
lgv=lgv|(pv0_aic'~_dxmiss);
avec[1]=beta[rows(beta)];
amat_temp[1,1:pv0_aic[1]]=beta[1:pv0_aic[1]]';
gmat_temp[1,1:pv0_aic[2]]=beta[1+pv0_aic[1]:sumc(pv0_aic[1:2])]';
tvec=tvec|rows(e0);
emat[rows(emat)-rows(e0)+1:rows(emat),1]=e0;
ecmcoef1=ecmcoef1|0;/*beta[rows(beta)-2];*/
ecmtratio1=ecmtratio1|_dxmiss;/*tstat[rows(beta)-2];*/

/*covariances by delta methods */
ase=ase|se[rows(beta)]^2;
acov=acov|sumc(sumc(cov0[1:pv0_aic[1],1:pv0_aic[1]]));
gcov=gcov|sumc(sumc(cov0[1+pv0_aic[1]:sumc(pv0_aic[1:2]),1+pv0_aic[1]:sumc(pv0_aic[1:2])]));
ccov=ccov|_dxmiss;
hwv=hwv|_dxmiss;

combi=pcombi(pv,p0);
i=2;
do while i<=n;
    yi=data[.,i];
    yis=datas[.,i];
    yiname=dataname[i];
    yisname=yiname $+ "s";
datai=yi~yis~y0;
ecm1_i0=leveldata[.,i]-leveldata[.,1];
ecm2_ii=leveldata[.,i]-leveldatas[.,i];

if aic==0;pvi_aic=pv;
else;
ic0={};
c_p=1;
do while c_p<=rows(combi);
{zname,ndata}=ardl(yiname~yisname~"L",datai,combi[c_p,.]',p0);
ndata=trim(ndata,maxc(pv)-maxc(combi[c_p,.]'),0);
if c_base==10 and i==2;
ndata=ndata~ecm1_i0[rows(ecm1_i0)-rows(ndata)+1:rows(ecm1_i0),.]
/*~ecm2_ii[rows(ecm2_ii)-rows(ndata)+1:rows(ecm2_ii),.]*/;
else;
ndata=ndata~ecm1_i0[rows(ecm1_i0)-rows(ndata)+1:rows(ecm1_i0),.]
~ecm2_ii[rows(ecm2_ii)-rows(ndata)+1:rows(ecm2_ii),.];
endif;
{beta,se,tstat,e,ic,cov,rsq_Bar}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
c_p=c_p+1;
ic0=ic0|ic';
endo;
    if aic==1;
        pvi_aic=combi[minindc(ic0[.,1]),.]';
        elseif aic==2;pvi_aic=combi[minindc(ic0[.,2]),.]';
    endif;
endif;
    {zname,ndata}=ardl(yiname~yisname~"L",yi~yis~y0,pvi_aic,p0);

if c_base==10 and i==2;/** only when base N eq of S to avoid perfect multico**/
ndata=ndata~ecm1_i0[rows(ecm1_i0)-rows(ndata)+1:rows(ecm1_i0),.];
    {beta,se,tstat,e,ic,cov,rsq_Bar}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
ecmcoef1=ecmcoef1|0;
ecmcoef2=ecmcoef2|beta[rows(beta)-1];
ecmtratio1=ecmtratio1|_dxmiss;
ecmtratio2=ecmtratio2|tstat[rows(beta)-1];
ecmjointf=ecmjointf|_dxmiss;
pvaluef=pvaluef|_dxmiss;
/*~ecm2_ii[rows(ecm2_ii)-rows(ndata)+1:rows(ecm2_ii),.]*/;
else;

ndata=ndata~ecm1_i0[rows(ecm1_i0)-rows(ndata)+1:rows(ecm1_i0),.]
~ecm2_ii[rows(ecm2_ii)-rows(ndata)+1:rows(ecm2_ii),.];
    {betar,ser,tstatr,er,icr,covr,rsq_Barr}=ols(ndata[.,1],ndata[.,2:cols(ndata)-2]~ones(rows(ndata),1));
    {beta,se,tstat,e,ic,cov,rsq_Bar}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
fstat=((er'er-e'e)/2)/(e'e/(rows(ndata)-rows(beta)));
ecmjointf=ecmjointf|fstat;
pvalue=cdffc(fstat,2,(rows(ndata)-rows(beta)));
pvaluef=pvaluef|pvalue;
    if pvalue<0.05;/*ecmcoef1=ecmcoef1|beta[rows(beta)-2];
ecmcoef2=ecmcoef2|beta[rows(beta)-1];
ecmtratio1=ecmtratio1|tstat[rows(beta)-2];
ecmtratio2=ecmtratio2|tstat[rows(beta)-1];
theta=beta[rows(beta)-2:rows(beta)-1];
icov_theta=invpd(cov);
chistat=(theta'icov_theta[rows(beta)-2:rows(beta)-1,rows(beta)-2:rows(beta)-1]*theta);
ecmjointf=ecmjointf|chistat;
pvaluef=pvaluef|cdfchic(chistat,rows(theta));*/
if abs(tstat[rows(beta)-2])<abs(tstat[rows(beta)-1]);
ndata=ndata[.,1:cols(ndata)-2]~ndata[.,cols(ndata)];
    {beta,se,tstat,e,ic,cov,rsq_Bar}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
ecmcoef1=ecmcoef1|0;
ecmcoef2=ecmcoef2|beta[rows(beta)-1];
ecmtratio1=ecmtratio1|_dxmiss;
ecmtratio2=ecmtratio2|tstat[rows(beta)-1];
elseif abs(tstat[rows(beta)-2])>=abs(tstat[rows(beta)-1]);
ndata=ndata[.,1:cols(ndata)-1];
    {beta,se,tstat,e,ic,cov,rsq_Bar}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
ecmcoef1=ecmcoef1|beta[rows(beta)-1];
ecmcoef2=ecmcoef2|0;
ecmtratio1=ecmtratio1|tstat[rows(beta)-1];
ecmtratio2=ecmtratio2|_dxmiss;
endif;

elseif pvalue>=0.05;ndata=ndata[.,1:cols(ndata)-2];
    {beta,se,tstat,e,ic,cov,rsq_Bar}=ols(ndata[.,1],ndata[.,2:cols(ndata)]~ones(rows(ndata),1));
ecmcoef1=ecmcoef1|0;
ecmcoef2=ecmcoef2|0;
ecmtratio1=ecmtratio1|_dxmiss;
ecmtratio2=ecmtratio2|_dxmiss;
else;
ecmcoef1=ecmcoef1|_dxmiss;
ecmcoef2=ecmcoef2|_dxmiss;
ecmtratio1=ecmtratio1|_dxmiss;
ecmtratio2=ecmtratio2|_dxmiss;
endif;

endif;/*for base N with eq of S **/

pvi_aic_v=pvi_aic_v|pvi_aic';rsq_bar_v=rsq_bar_v|rsq_Bar;ctratio[i]=tstat[sumc(pvi_aic[1:2])+1];
/** matrices for GIRF **/
avec[i]=beta[rows(beta)];
amat_temp[i,1:pvi_aic[1]]=beta[1:pvi_aic[1]]';
gmat_temp[i,1:pvi_aic[2]]=beta[1+pvi_aic[1]:sumc(pvi_aic[1:2])]';
cmat_temp[i,1:pvi_aic[3]+1]=beta[1+sumc(pvi_aic[1:2]):1+sumc(pvi_aic[1:3])]';
tvec=tvec|rows(e);
emat[rows(emat)-rows(e)+1:rows(emat),i]=e;

/*covariances by delta methods */
lgv=lgv|pvi_aic';
ase=ase|se[rows(beta)]^2;
acov=acov|sumc(sumc(cov[1:pvi_aic[1],1:pvi_aic[1]]));
gcov=gcov|sumc(sumc(cov[1+pvi_aic[1]:sumc(pvi_aic[1:2]),1+pvi_aic[1]:sumc(pvi_aic[1:2])]));
ccov=ccov|sumc(sumc(cov[1+sumc(pvi_aic[1:2]):1+sumc(pvi_aic[1:3]),1+sumc(pvi_aic[1:2]):1+sumc(pvi_aic[1:3])]));

if pvi_aic[3]==0;ccov2=ccov2|100000000;
else;
ccov2=ccov2|sumc(sumc(cov[2+sumc(pvi_aic[1:2]):2+sumc(pvi_aic[1:3]),2+sumc(pvi_aic[1:2]):2+sumc(pvi_aic[1:3])]));
endif;

/** hausman wu **/
    if rows(ndata)>rows(e0);ndata_hw=ndata[rows(ndata)-rows(e0)+1:rows(ndata),.];e0_hw=e0;
    elseif rows(ndata)<rows(e0);e0_hw=e0[-rows(ndata)+rows(e0)+1:rows(e0),.];ndata_hw=ndata;
    else;    ndata_hw=ndata;e0_hw=e0;endif;
    {aaa,bbb,hw,ccc,ddd,eee,jjj}=ols(ndata_hw[.,1],ndata_hw[.,2:cols(ndata)]~ones(rows(ndata_hw),1)~e0_hw);
/*"----------------------------";
$zname[1]~"coef"~"t-ratio";
    $(zname[2:cols(zname)]~"inpt")'~ftocv(beta~tstat,1,4);
"Hausman-Wu:";;hw[rows(hw)];*/
hwv=hwv|hw[rows(hw)];
LONDON:
i=i+1;
endo;

/** WH matrix **/
hwvmat=hwvmat~(rotater(hwv',c_base)');
/* summary statistics, sum of coeffeicints */
summ=avec~(avec./sqrt(ase));
suma=sumc(amat_temp')~(sumc(amat_temp')./sqrt(acov));
sumg=sumc(gmat_temp')~(sumc(gmat_temp')./sqrt(gcov));
sumq=sumc(cmat_temp[.,2:cols(cmat_temp)]')~(sumc(cmat_temp[.,2:cols(cmat_temp)]')./sqrt(ccov2));
sumt=(cmat_temp[.,1])~ctratio;
/*
sumq=sumc(cmat_temp')~(sumc(cmat_temp')./sqrt(ccov2));*/
/**/
format /rd 7,5;
resultsmat=summ~suma~sumg~sumq~sumt~hwv~lgv~rsq_bar_v~ecmcoef1~ecmtratio1~ecmcoef2~ecmtratio2~ecmjointf~pvaluef;
;
namevector=" "~"inpt"~" "~"OwnLag"~" "~"NeighbLag"~" "~"BaseLag"
~" "~"BaseCntmp"~" "~"Wu-Haus"~"k_own"~"k_neib"~"k_Base"~"Rsq_b"
~"EC1"~"tratio"~"EC2"~"tratio"~"Wald(ec1,2)"~"pvalue";
"++++++++++++++++++++++++++++++++++++++++++++++++++";
$"DOMINANT"~" REGION"~" IS"~csname[1];
if aic==0;"Lag-order chosen by user";
elseif aic==1;"Lag-order chosen by AIC";
elseif aic==2;"Lag-order chosen by SBC";endif;
"SUM OF COEFFICIENTS WITH T RATIO (BY DELTA METHODS)";
$namevector|((rotater(csname',c_base)')~ftocv(rotater(resultsmat',c_base)',0,3));
format /rd 16,12;

c_base=c_base+1;
endo;
if c_base/=1;
format /rd 7,5;
"---------------------------";
if aic==0;"Lag-order chosen by user";
elseif aic==1;"Lag-order chosen by AIC";
elseif aic==2;"Lag-order chosen by SBC";endif;
"WU HAUSMAN TEST STATISTIC MATRIX";
$(" "~csnameo')|((csnameo)~ftocv(HWVMAT,0,2));
format /rd 16,12;
endif;

/*** matrces for impulse response********************/
/* rank deficient cointegrating matrix H**/
ecmcoef1[1]=0;
hmat=diagrv(eye(rows(ecmcoef1)),ecmcoef1+ecmcoef2);
hmat[.,1]=hmat[.,1]-ecmcoef1;
hmat=hmat-(ecmcoef2.*Smat);
/*** N+1 x (N+1)maxp (horizontary concatinated) **/
amat={};gmat={};cmat={};
c0=cmat_temp[.,1]~zeros(n,n-1);
ck=1;
do while ck<=maxp;
    amat=amat~(eye(n).*amat_temp[.,ck]);
    gmat=gmat~(gmat_temp[.,ck].*Smat);
    cmat=cmat~(cmat_temp[.,ck+1]~zeros(n,n-1));
    ck=ck+1;
endo;

tminmat=zeros(cols(emat),cols(emat));
ci=1;
do while ci<=cols(emat);
    cj=1;
    do while cj<=cols(emat);
        tminmat[ci,cj]=minc(tvec[ci]|tvec[cj]);
        cj=cj+1;
    endo;
ci=ci+1;
endo;

zigma=emat'emat./tminmat;
zigma[2:rows(zigma),1]=zeros(rows(zigma)-1,1);
zigma[1,2:rows(zigma)]=zeros(rows(zigma)-1,1)';

/** mu **//*
mu_temp=zeros(n,n);
ck=1;
do while ck<=maxp;
    mu_temp=mu_temp+
         amat[.,1+n*(ck-1):n*ck]
        +gmat[.,1+n*(ck-1):n*ck]
        +cmat[.,1+n*(ck-1):n*ck];
    ck=ck+1;
endo;
mu=inv(eye(n)-c0-mu_temp)*avec;
*/
/* R matrix */
rmat=eye(n)+c0;
/* pi matrix (N+1 x N+1*maxp)*/
paimat=rmat*hmat;

/* gama matrix (N+1 x N+1*maxp)*/
gamamat={};
ck=1;
do while ck<=maxp;
    gamamat= gamamat~(rmat*(
         amat[.,1+n*(ck-1):n*ck]
        +gmat[.,1+n*(ck-1):n*ck]
        +cmat[.,1+n*(ck-1):n*ck]));
    ck=ck+1;
endo;

/* phi matrix (N+1 x N+1*maxp)*/
phimat=eye(n)+paimat+gamamat[.,1:n];
ck=2;
do while ck<=maxp;
    phimat= phimat~(
         gamamat[.,1+n*(ck-1):n*ck]
        -gamamat[.,1+n*(ck-2):n*(ck-1)]
        );
    ck=ck+1;
endo;
phimat=phimat~(-gamamat[.,1+n*(maxp-1):n*(maxp)]);

/** companion form **/
if charctrsticvalue==1;
Fmat=phimat|((eye(maxp).*.eye(n))~(zeros(maxp,1).*.eye(n)));

"eigenvalues of companion form of phi";
{ var,vai } = eigrg(fmat);
mod=sqrt(var^2+vai^2);
"max modulus:";;maxc(mod);
$"eigv"~""~"modulus";
eig(fmat)~mod;

endif;

/****************************/
/* impulse response*/
if impulseresponse==0; goto nogirf;endif;
h=100;
zhai_mat=eye(n);

shock=zeros(n,1);
shock[shocki]=1;

i=1;
do while i<=h;
    if i<=maxp+1;
        i_temp=cols(zhai_mat)/n;
        zhai_temp=zeros(n,n);
            c_i=1;
            do while c_i<=i_temp;
                zhai_temp=zhai_temp+phimat[.,1+(c_i-1)*n:c_i*n]*zhai_mat[.,1+(i_temp-c_i)*n:(i_temp-c_i+1)*n];
                c_i=c_i+1;
            endo;
        zhai_mat=zhai_mat~zhai_temp;
    else;
        zhai_temp=zeros(n,n);
            c_i=1;
            do while c_i<=maxp+1;
                zhai_temp=zhai_temp+phimat[.,1+(c_i-1)*n:c_i*n]*zhai_mat[.,1+(i-c_i)*n:(i-c_i+1)*n];
                c_i=c_i+1;
            endo;
        zhai_mat=zhai_mat~zhai_temp;
    endif;
i=i+1;
endo;

girf={};
i=1;
do while i<=h+1;
    zhai=zhai_mat[.,1+(i-1)*n:i*n];
    girf=girf~zhai*rmat*zigma*shock/(sqrt(shock'zigma*shock));
    i=i+1;
endo;
dgirf=(girf'-lag(girf'))';
dgirf[.,1]=girf[.,1];

ppp=xlswritem(seqa(0,1,h+1)'|girf,drctry2,"b1",aic+1,"");                
ppp=xlswritesa(csname,drctry2,"a2",aic+1,"");                
ppp=xlswritem(seqa(0,1,h+1)'|dgirf,drctry3,"b1",aic+1,"");                
ppp=xlswritesa(csname,drctry3,"a2",aic+1,"");     

nogirf:  
aic=aic+1;
endo;
    

/*
dataname="y"~"x1"~"x2";
data=y~x1~x2;
pv={1,1,2};
p0={1,1,0}; 0 if include contemporaneous, 1 only lagged 
           note first one is 1.

{zname,ndata}=ardl(dataname,data,pv,p0);
$zname;
ndata;
*/
proc(2)=ardl(dataname,data,pv,p0);
local ot,k,p0s,ndata,maxp,ck,zk,pk,zk_temp,zname,zkname,cp,zkname_temp;
local pk0;

ot=rows(data);
k=cols(data);
p0s=p0;p0s[1]=0;
ndata={};
maxp=maxc(pv);

if ot<k-1+sumc(pv); "Number of Parameter to estimate exceeds T";endif;

ck=1;
do while ck<=k;
    zk=data[.,ck];
    pk=pv[ck];
    pk0=p0s[ck];
    zk_temp=ones(1,pk+1).*.zk;
    zk_temp=rotater(zk_temp',seqa(0,1,pk+1))';
    if pk0==1;zk_temp=zk_temp[.,2:cols(zk_temp)];endif;
ndata=ndata~trim(zk_temp,maxp,0);
ck=ck+1;
endo;

zname={};
ck=1;
do while ck<=k;
    zkname=dataname[ck];
    pk=pv[ck];
    pk0=p0s[ck];
        cp=pk0;
        do while cp<=pk;
                if cp==0;zkname_temp=zkname;
                    else;
                    zkname_temp=zkname $+ "(" $+ ftocv(-cp,0,0) $+ ")";
                endif;
            zname=zname~zkname_temp;
        cp=cp+1;
    endo;
ck=ck+1;
endo;

retp(zname,ndata);
endp;

proc(7)=ols(y,x);
local t,k,beta,e,sig2,cov,se,tstat,aic,sbc,ic,rsq_bar;
t=rows(y);
k=cols(x);
    if rank(x'x)<cols(x'x);$"";
    beta=ones(cols(x),1)*_dxmiss;
    se=beta;
    tstat=beta;
    e=ones(rows(x),1)*_dxmiss;
    ic=ones(2,1)*_dxmiss;
    cov=ones(cols(x),cols(x))*_dxmiss;
    rsq_bar=_dxmiss;
    goto out;endif;
beta=inv(x'x)*x'y;
e=y-x*beta;
sig2=e'e/(t-k);
cov=sig2*inv(x'x);
se=sqrt(diag(cov));
tstat=beta./se;
aic=ln((t-k)*sig2/t)+2*k/t;
sbc=ln((t-k)*sig2/t)+(ln(t)/t)*k;
ic=aic|sbc;
rsq_bar=1-sig2/(stdc(y)^2);
out:
retp(beta,se,tstat,e,ic,cov,rsq_bar);
endp;

            
    
/*
dataname="y"~"x1"~"x2";
data=y~x1~x2;
pv={1,1,2};
p0={1,1,0}; 0 if include contemporaneous, 1 only lagged 
           note first one is 1.

{combi}=pcombi(pv,p0);
all prodc(pv+p0.==1) combinations of lag orders 
*/  

proc(1)=pcombi(pv,p0);
local ppv,c_temp,c_p,cr;
ppv=pv+(p0.==0);
c_temp=seqa(p0[1],1,ppv[1]);
c_p=2;
do while c_p<=rows(pv);
    cr=rows(c_temp);
    c_temp=c_temp.*.ones(ppv[c_p],1);
    c_temp=c_temp~(ones(cr,1).*.seqa(p0[c_p],1,ppv[c_p]));
    c_p=c_p+1;
endo;    

retp(c_temp);
endp;